

#include <stdint.h> 
#include <avr\interrupt.h>
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>

#include "debug.h"


//mit Oszilloscope Testpin am Controller an geeigneter Steelle watchen.
// Zahl der Toggles gibt Position an. 
#ifdef  TOGGLE_FLAG_USED
// ****************************************************************
void Toggle_Bit(uint8_t u8Cnt)
// ****************************************************************
{ // #include <util\delay.h>  muss da sein
TOGGLE_DIRREG |= TOGGLE_BIT;
while(u8Cnt--)
	{
	TOGGLE_PORT |= TOGGLE_BIT;
	_delay_us(1);
	TOGGLE_PORT &= ~TOGGLE_BIT;
	_delay_us(1);
	};
};
#endif

#ifdef TOGGLE_STATIC_BIT_USED
// ***********************
void Toggle_On(void)
// ***********************
{
TOGGLE_PORT |= TOGGLE_BIT;
};

// ***********************
void Toggle_Off(void)
// ***********************
{
TOGGLE_PORT &= ~TOGGLE_BIT;
};
#endif 

#ifdef BYTE_TO_BIN_USED
// *******************************************************************
char * ByteToBin(uint8_t u8Byte)
// *******************************************************************
{
static char caHex[9]; //groesse 8+1
char * pcParser = caHex;
int8_t i8NN=7;
do
	{
	if( u8Byte & (1 << i8NN) )
		{
		*pcParser = '1';
		}
	else
		{
		*pcParser = '0';
		};
	pcParser++;
	}while(i8NN--);
caHex[8]=0; //Terminierung
return caHex;
};
#endif 


//WORD Anzeige in Binaerer Form
#ifdef WORD_TO_BIN_USED
// *******************************************************************
char * WordToBin(uint16_t u16Word)
// *******************************************************************
{
static char ucaHex[18]; // Array  zeigt Lcke 00000000 00000000
char * pcParser = ucaHex;
uint8_t u8NN=15;
do
	{
	if(u8NN == 7)
		{*pcParser =' '; pcParser++;}; // Fge Lcke ein im BYTE
	if(u16Word & (1<<u8NN) )
		{
		*pcParser = '1';
		}
	else
		{
		*pcParser = '0';
		};
	pcParser++;
	}while(u8NN--);
ucaHex[17]=0;
return  ucaHex;
};
#endif


#ifdef BYTE_TO_HEX_USED
static char caHex[5]; //groesse 8+1
// **************************
//Hilfsfuktion;
void FillHex(uint8_t u8Pos, uint8_t u8Mem)
// **************************
{
if(u8Mem > 9 )
	{
	switch(u8Mem)
		{
		case 10:
			{
			caHex[u8Pos]='A';
			break;
			};
		case 11:
			{
			caHex[u8Pos]='B';
			break;
			};
		case 12:
			{
			caHex[u8Pos]='C';
			break;
			};
		case 13:
			{
			caHex[u8Pos]='D';
			break;
			};
		case 14:
			{
			caHex[u8Pos]='E';
			break;
			};
		case 15:
			{
			caHex[u8Pos]='F';
			break;
			};
		};
	}
else
	{
	caHex[u8Pos]=u8Mem+48; //ASCII ZAHL 0
	};
}

// ******************************
char * ByteToHex(uint8_t u8Byte)
// ******************************
{
caHex[0]='0';
caHex[1]='x';
FillHex(2,(u8Byte & 0xF0) >> 4);
FillHex(3,u8Byte & 0x0F);
caHex[4]=0;
return caHex;
};
#endif 

#ifdef SHOW_BYTE_USED
// ******************************
void ShowByte(uint8_t u8Byte, char * pText, uint8_t u8Nr)
// ******************************
{
char caNumStr[10];
uart_putc(13); uart_putc(10);
uart_puts_p( PSTR("-------------------"));
uart_putc(13); uart_putc(10);
uart_puts(pText);
uart_puts_p( PSTR(";\t"));
uart_puts_p( PSTR("Nr:"));
uart_puts( itoa( u8Nr, caNumStr, 10) );
uart_puts_p( PSTR("\t="));
uart_puts( itoa( u8Byte, gcaNumStr, 10) );
uart_puts_p( PSTR("\tB: "));
uart_puts( ByteToBin( u8Byte ));
uart_puts_p( PSTR("\tH: "));
uart_puts( ByteToHex( u8Byte ));
};
#endif 

/*
// Textausgabe eines Bytes  mit allen Darstellungen
// ******************************
void ShowByte(uint8_t u8Byte, uint8_t u8Nr)
// ******************************
{
char caNumStr[10];
uart_putc(13); uart_putc(10);
uart_puts_p( PSTR("-------------------"));
uart_putc(13); uart_putc(10);
uart_puts_p( PSTR("Nr:"));
uart_puts( itoa( u8Nr, caNumStr, 10) );
uart_puts_p( PSTR("\t="));
uart_puts( itoa( u8Byte, gcaNumStr, 10) );
uart_puts_p( PSTR("\tB: "));
uart_puts( ByteToBin( u8Byte ));
uart_puts_p( PSTR("\tH: "));
uart_puts( ByteToHex( u8Byte ));
};
*/

/*
uart_putc(13); uart_putc(10);
ShowByte(u8Low_0_Maske, "LMSK", u8Row);
ShowByte(u8High_0_Maske, "HMSK", u8Row);

ShowByte(u8Split_Low_Data, "LDat", u8Row);
ShowByte(u8Split_High_Data, "HDat", u8Row);
ShowByte(u8SParkFun8x7Data, "Full", u8Row);
ShowByte(gu8ParkFun[u8Row], "ORG", u8Row);
ShowByte(A_F_DDR , "DDAF", u8Row);
ShowByte(G_H_DDR , "DDGH", u8Row);
ShowByte(A_F_PORT , "POAF", u8Row);
ShowByte(G_H_PORT , "POGH", u8Row);	
*/

/*
uart_putc(13); uart_putc(10);
uart_puts(  dtostrf(  RAND_MAX,10,5,gcaNumStr) );
*/